/*
	sc_packet_window.h - data contained in each window which is private
	to packet windows
*/
#include <controlmgr.h>
#include <EventMgr.h>

#define vscroll_ctl	0
#define NUM_PAK_CTL 1	/*number of controls in the packet window*/
#define PAK_CTL_RES_BASE 0	/*offset of packet controls*/
/*information for a packet display window*/
typedef struct {
	long draw_packet_num;	/*first packet displayed*/
	long draw_pak_max; 		/*last packet allowed to display*/
	Rect draw_pak_rect;		/*draw packets in here*/
	int draw_pak_width;		/*draw this many characters per line*/
	ControlHandle ctls[NUM_PAK_CTL]; /*this windows controls*/
} pak_windef;

void e_pak_grow(Point);
void e_pak_update_event(void);
void e_pak_activate(void);
void e_pak_deactivate(void);
void e_scope_grow(Point);
void e_pak_down_content(EventRecord *);
