/*
	pdc.h - pdl compiler .h interface file
*/

#define PDC_EOF_ch (-1)
struct pdc_R {
	long pdc_size;		/*number of characters left to read*/
	char *pdc_nextch;	/*pointer to the next character in input stream*/
	int pdc_cur_ch;	/*the current input character*/
	int (*pdc_load_buf)(); /*function to load the next buffers worth of data*/
};

typedef struct pdc_R pdc;

#define TOK_eof 		(0)
#define TOK_int 		(1)
#define TOK_left_paren	(2)
#define TOK_right_paren	(3)
#define TOK_tick 		(4)
#define TOK_symbol 		(5)

struct symbol_R {
	char *sy_txt;		/*pointer to c string of symbol text*/
};
typedef struct symbol_R symbol;
#ifdef RUBBISH
struct token_R {
	int tok_kind;	/*token kind*/
	int tok_radix;	/*radix for int/char constants*/
	long tok_value;	/*value for int/char constants*/
	symbol_pt tok_sym; /*symbol table entry for TOK_symbol*/
};
typedef struct token_R token;
#endif
