#include "XintYY.h"
#include "pdl_data.h"
#include "sc_pdl_dat.h"

pdl_extern(ip)		/*iptcp is in it's own file*/
pdl_extern(arp)

/*appletalk socket names*/
pdl_begin(socket_names,NIL)
	name("RTMPsok",0x1)
	name("NISsok",0x2)
	name("ECHOsok",0x4)
	name("ZIPsok",0x6)
pdl_end

pdl_begin(nbp_item,"nbp_item")
 field("enet",16,DEC)
 field("enod",8,DEC)
 field("esok",8,DEC)
 	pdl_gosub(socket_names)
 field("enumb",8,DEC)
 field("Obj",0,CNT_STR)
 field("Typ",0,CNT_STR)
 field("Zon",0,CNT_STR)
pdl_end

pdl_begin(NBP,"NBP")
 field("NBPty",4,DEC)			/*nbp type*/
 	name("BrRq",1)
 	name("LkUp",2)
 	name("Reply",3)
 field("count",4,DEC|VLOAD(t0))	/*load up number of times to do it*/
 field("id",8,DEC)				/*nbp id*/
 loop_count(t0,nbp_item)
 thats_all
pdl_end

pdl_begin(RTMPreq,"RTMPreq")
 field("cmd",8,HEX)
	name("request",1)
 thats_all
pdl_end

pdl_begin(RTMPresp_item,"RTMPresp_item")
 field("netn",16,DEC)
 field("dist",8,DEC) 
pdl_end

pdl_begin(RTMPresp,"RTMPresp")
 field("sndnet",16,DEC)
 field("idlen",8,DEC|VLOAD(t0))
 pdl_special(RTMPidpad)				/*set t1 to padding based on t0*/
 field("0",SIND(t1),DEC)			/*pad to a byte boundry*/
 field("sndid",SIND(t0),DEC)
 loop_till_end(RTMPresp_item)
 thats_all
pdl_end

pdl_begin(ATP,"ATP")
 field("func",2,DEC)		/*atp function code*/
	name("TReq",1)
	name("TResp",2)
	name("TRel",3)
 field("XO",1,DEC)
 field("EOM",1,DEC)
 field("STS",1,DEC)
 field("0",3,DEC)
 field("bm_seq",8,HEX)
 field("tid",16,HEX)
 field("usr",32,HEX)
pdl_end

pdl_begin(zipqry_item,"zipqry_item")
 field("net",16,DEC)
pdl_end

pdl_begin(zipqry,NIL)
 loop_count(zipcount,zipqry_item)
 thats_all
pdl_end

pdl_begin(zipreply_item,"zipreply_item")
 field("net",16,DEC)
 field("nam",0,CNT_STR)
pdl_end

pdl_begin(zipreply,NIL)
 loop_count(zipcount,zipreply_item)
 thats_all
pdl_end

pdl_begin(zipdwn,NIL)
 thats_all
pdl_end

pdl_begin(goup,NIL)
 field("0",16,DEC)
 field("nam",0,CNT_STR)
 thats_all
pdl_end

pdl_begin(ZIP,"ZIP")
 pdl_zero(proto)
 field("zipty",8,DEC)
 	protocol("query",zipqry,1,proto)
 	protocol("zreply",zipreply,2,proto)
 	protocol("godown",zipdwn,3,proto)
 	protocol("goup",goup,4,proto)
 field("count",8,DEC|VLOAD(zipcount))
 pdl_indirect_gosub(proto)
pdl_end

pdl_begin(EP,"EP")
 field("epty",8,DEC)
	name("req",1)
	name("epreply",2)
pdl_end

pdl_begin(ddp_common,NIL)
pdl_zero(proto)
field("ddpty",8,VIND(ddp_type)|DEC|CNTR(ddp_cntr)) /*fake field for ddp packet type*/
	protocol("RTMPresp",RTMPresp,1,proto)
	protocol("NBP",NBP,2,proto|CNTR_scope)
	protocol("ATP",ATP,3,proto|CNTR_scope|CNTR_reject)
	protocol("EP",EP,4,proto)
	protocol("RTMPreq",RTMPreq,5,proto|CNTR_scope)
	protocol("ZIP",ZIP,6,proto)
	protocol("ip",ip,22,proto|CNTR_scope)		/*ip/tcp*/
	protocol("arp",arp,23,proto|CNTR_scope)
pdl_indirect_gosub(proto)
pdl_end

/*appletalk short ddp packet*/
pdl_begin(sddp,"sddp")
 field("0",6,HEX)		/*reserved should be zero*/
 field("ddplen",10,DEC)	/*packet length*/
 field("dsok",8,DEC)	/*destination socket*/
 	pdl_gosub(socket_names)
 field("ssok",8,DEC)	/*source socket*/
 	pdl_gosub(socket_names)
 field("ddpty",8,NOPRINT|VLOAD(ddp_type)) /*remember the ddp type,print it later*/
 pdl_gosub(ddp_common)	/*now that we know the ddp type, join long ddp code*/
pdl_end

/*appletalk long ddp packet*/
pdl_begin(lddp,"lddp")
 field("0",2,HEX)		/*reserved should be zero*/
 field("hop",4,DEC)		/*hop count*/
 field("ddplen",10,DEC)	/*packet length*/
 field("cks",16,HEX)	/*ddp checksum*/
 field("dnet",16,DEC)	/*destination net*/
 field("snet",16,DEC)	/*source network*/
 field("dnod",8,DEC)	/*destination node*/
 field("snod",8,DEC)	/*source node*/
 field("dsok",8,DEC)	/*destination socket*/
 	pdl_gosub(socket_names)
 field("ssok",8,DEC)	/*source socket*/
 	pdl_gosub(socket_names)
 field("ddpty",8,NOPRINT|VLOAD(ddp_type)) /*remember the ddp type,print it later*/
 pdl_gosub(ddp_common)	/*now that we know the ddp type, join long ddp code*/
pdl_end

/*
	mazeware+ packets
*/
pdl_begin(mazewp,"mazewp")
 field("0",6,HEX)		/*reserved should be zero*/
 field("mazlen",10,DEC)	/*length of a mazewar packet*/
pdl_end

pdl_begin(pdl_root,"pdl_root")
 field("lapdst",8,HEX)		/*lap destination node*/
 field("lapsrc",8,HEX)		/*lap source node*/
 pdl_zero(proto)
 field("lapty",8,HEX|CNTR(lap_cntr))	/*lap type*/
	cnt_name("lapENQ",0x81,CNTR_reject)	/*lap address in use enquire*/
	cnt_name("lapACK",0x82,CNTR_reject) /*answer enq, that address in use*/
	cnt_name("lapRTS",0x84,CNTR_reject) /*request to send a packet*/
	cnt_name("lapCTS",0x85,CNTR_reject) /*clear to send a packet*/
	protocol("sddp",sddp,1,proto|CNTR_scope) /*appletalk short lap*/
	protocol("lddp",lddp,2,proto|CNTR_scope) /*appletalk long lap*/
	protocol("mazewp",mazewp,0x30,proto)	/*a mazewar packet*/
 pdl_indirect_gosub(proto)
pdl_end

pdl_begin(pdl_hdr,"pdl_hdr")
 field("paknm",32,DEC)		/*which packet it is*/
 field("dat",32,NOPRINT)	/*skip the packet pointer for now*/
 field("time",32,DEC)
 field("err",16,HEX)
 	name("noerr",0)
 	name("overr",1)
 	name("noabort",2)
 	name("crc",3)
 field("siz",16,DEC)		/*packet size*/
 field("hwcrc",16,HEX)		/*hardware crc*/
pdl_end

/* dummy code to declare names for the miscellaneous counters*/
pdl_begin(misc_counts,"misc_counts")
 field("misc",8,HEX|CNTR(misc_cntr))	/*lap type*/
	cnt_name("crc_ok",0,CNTR_scope)
	name("crc_bad",1)
	name("overrun",2)
	name("no_abort",3)
	name("tooshort",4)
pdl_end


