/*
	ip pdl descriptions
	
	implemented:
		ICMP 	- all
		UDP 	- all
		IP		- no options
		TCP		- no options
		ARP		- no
		TFP		- no
*/
#include "XintYY.h"
#include "pdl_data.h"
#include "sc_pdl_dat.h"

pdl_extern(ip)		/*forward reference, icmps have ip's in them*/

pdl_begin(arp,"arp")
 field("ar_hrd",16,DEC)	/*hardware addess space */
 	name("hrd_ab",3)	/*appletalk*/
 field("ar_pro",16,DEC)
 	name("dod_ip",2048)	/*translate to/from DOD internet */
 field("ar_hln",8,DEC)	/*hardware length*/
 field("ar_pln",8,DEC)	/*proticol length*/
 field("ar_op",16,DEC)	/*arp opcode*/
 	name("op_req",1)
 	name("op_reply",2)
 /* ar_sha */
 field("ar_s_anet",16,DEC)
 field("ar_s_node",8,DEC)
 field("ar_s_port",8,DEC)
 field("ar_spa",32,IP_ADR)
 field("ar_t_anet",16,DEC)
 field("ar_t_node",8,DEC)
 field("ar_t_port",8,DEC)
 field("ar_tpa",32,IP_ADR)
 thats_all
pdl_end

/*
	parse an ip header contained inside a icmp packet
*/
pdl_begin(icmp_ip_header,NIL)
pdl_gosub(ip)
pdl_end

pdl_begin(icmp_cks,"icmp_cks")
 field("cks",16,HEX)
 field("unused",32,HEX)
 pdl_gosub(icmp_ip_header)
pdl_end

pdl_begin(dst_unreach,"dst_unreach")
 field("code",8,DEC)
	name("net_unreachable",0)
	name("host_unreachable",1)
	name("protocol_unreach",2)
	name("port_unreachable",3)
	name("need_frag_but_DF",4)
	name("src_route_failed",5)
 pdl_gosub(icmp_cks)
pdl_end

pdl_begin(icmp_timex,"icmp_timex")
 field("code",8,DEC)
 	name("time_live_exed",0)
 	name("frag_reassm_exed",1)
 pdl_gosub(icmp_cks)
pdl_end

pdl_begin(bad_param,"bad_param")
 field("code",8,DEC)
 	name("bad_param_val",0)
 field("cks",16,HEX)
 field("err_ptr",16,HEX)
 field("unused",24,HEX)
 pdl_gosub(icmp_ip_header)
pdl_end

pdl_begin(src_quench,"src_quench")
field("code",8,DEC)
 	name("src_too_fast",0)
pdl_gosub(icmp_cks)
pdl_end

pdl_begin(icmp_redirect,"icmp_redirect")
 field("code",8,DEC)
 	name("redirect_net",0)
 	name("redirect_host",1)
 	name("redirect_srv_net",2)
 	name("redirect_srv_host",3)
 field("cks",16,HEX)
 field("err_ptr",16,HEX)
 field("unused",24,HEX)
 pdl_gosub(icmp_ip_header)
pdl_end

pdl_begin(icmp_echo,"icmp_echo")
field("code",8,DEC)
 	name("som_echo",0)
pdl_gosub(icmp_cks)
pdl_end

pdl_begin(icmp_time,"icmp_time")
 field("code",8,DEC)
 	name("som_time",0)
 field("cks",16,HEX)
 field("id",8,HEX)
 field("seq",8,HEX)
 field("originate",32,DEC)
 field("receive",32,DEC)
 field("transmit",32,DEC)
 thats_all
pdl_end

pdl_begin(icmp_info,"icmp_info")
 field("code",8,DEC)
 	name("som_type",0)
 field("cks",16,HEX)
 field("id",8,HEX)
 field("seq",8,HEX)
pdl_end

pdl_begin(icmp,"icmp")
pdl_zero(proto)
field("icmpty",8,DEC|VLOAD(proto))
	protocol("echo_rply",icmp_echo,0,proto)
	protocol("dst_unreach",dst_unreach,3,proto)
	protocol("src_quence",src_quench,4,proto)
	protocol("redirect",icmp_redirect,5,proto)
	protocol("echo_req",icmp_echo,8,proto)
	protocol("time_exceded",icmp_timex,11,proto)
	protocol("bad_param",bad_param,12,proto)
	protocol("timestamp_req",icmp_time,13,proto)
	protocol("timestamp_rply",icmp_time,14,proto)
	protocol("icmp_info_req",icmp_info,15,proto)
	protocol("icmp_info_rply",icmp_info,16,proto)
pdl_indirect_gosub(proto)
pdl_end

pdl_begin(udp,"udp")
 field("src_port",16,DEC)
 field("dst_prot",16,DEC)
 field("len",16,DEC)
 field("cks",16,HEX)
pdl_end

pdl_begin(tcp,"tcp")
 field("src_port",16,DEC)
 field("dst_prot",16,DEC)
 field("seq",32,DEC)
 field("ackn",32,DEC)
 field("doffs",4,DEC)
 field("0",6,DEC)
 field("URG",1,DEC)
 field("ACK",1,DEC)
 field("PSH",1,DEC)
 field("RST",1,DEC)
 field("SYN",1,DEC)
 field("FIN",1,DEC)
 field("win",16,DEC)
 field("cks",16,HEX)
 field("urgp",16,HEX)
pdl_end

pdl_begin_forward(ip,"ip")
field("vers",4,DEC)
	name("IPv4",4)
field("ihl",4,DEC)
field("precd",3,DEC)
	name("net_ctl",7)
	name("i_net_ctl",6)
	name("critic",5)
	name("flash_over",4)
	name("flash",3)
	name("immediate",2)
	name("priority",1)
	name("routine",0)
field("delay",1,DEC)
	name("dnormal",0)
	name("dlow",1)
field("through",1,DEC)
	name("tnormal",0)
	name("thigh",1)
field("reli",1,DEC)
	name("rnormal",0)
	name("rhigh",1)
field("0",2,DEC)
field("len",16,DEC)
field("id",16,DEC)
field("0",1,DEC)
field("DF",1,DEC)
	name("may",0)
	name("dont",1)
field("MF",1,DEC)
	name("last",0)
	name("fmore",1)
field("frago",13,DEC)
field("live",8,DEC|VLOAD(ip_type))
pdl_zero(ip_type)
field("ipty",8,DEC|CNTR(ip_cntr))
	protocol("tcp",tcp,6,ip_type)
	protocol("ICMP",icmp,1,ip_type)
	protocol("UDP",udp,17,ip_type)
field("hcks",16,DEC)
field("sadr",32,IP_ADR)
field("dadr",32,IP_ADR)

pdl_indirect_gosub(ip_type)
pdl_end
