; the packet hardware header made up by the seer device
(pdl_struct pdl_hdr
 (pdl_field paknm 32 dec)
 (pdl_field dat 32 noprint)
 (pdl_field time 32 dec)
 (pdl_field err 16 hex)
  (pdl_name nil
  	('noerr 0x0)
  	('overr 0x1)
  	('noabort 0x2)
  	('crc 0x3))
 (pdl_field siz 16 dec)
 (pdl_field hwcrc 16 hex)
)

; alap packet
(pdl_struct pdl_root
 (pdl_field lapdst 8 hex)
 (pdl_field lapsrc 8 hex)
 (pdl_field lapty 8 hex :counter cnt1)
  (pdl_name proto
	('lapENQ 0x81 :reject)
  	('lapACK 0x82 :reject)
  	('lapRTS 0x84 :reject)
  	('lapCTS 0x85 :reject)
  	(sddp     0x1 :on_scope)
  	(lddp     0x2 :on_scope)
  	(mazewp  0x30))
 (funcal proto)
)

; short ddp packet
(pdl_struct sddp
 (pdl_field 0 6 hex)
 (pdl_field ddplen 10 dec)
 (pdl_field dsok 8 dec)
 (funcal 'socket_names)
 (pdl_field ssok 8 dec)
 (funcal 'socket_names)
 (pdl_field ddpty 8 noprint :value_to reg3)
 (funcal 'ddp_common)
)

; the names of ddp sockets
(pdl_struct ddp_socket_names
  (pdl_name nil
  	('RTMPsok 1)
  	('NISsok 2)
  	('ECHOsok 4)
  	('ZIPsok 6))
)

; decode the ddp type file common to both ddp short and long packets
(pdl_struct ddp_common
 (pdl_field ddpty 8 dec :counter cnt2 :value_from reg3)
  (pdl_name proto
    (RTMPresp  1)
    (NBP 	   2 :on_scope)
    (ATP       3 :on_scope :reject)
    (EP        4)
    (RTMPreq   5 :on_scope)
    (ZIP       6)
    (ip       22 :on_scope)
    (arp      23 :on_scope))
 (funcal proto)
)

(pdl_struct RTMPresp
 (pdl_field sndnet 16 dec)
 (pdl_field idlen 8 dec :value_to reg1)
 (setq reg2 (remainder reg1 8))
 (pdl_field 0 0 dec :size_from reg2)
 (pdl_field sndid 0 dec :size_from reg1)
 (loop nil 'RTMPresp_item)
 (thats_all)
)

(pdl_struct RTMPresp_item
 (pdl_field netn 16 dec)
 (pdl_field dist 8 dec)
)

(pdl_struct NBP
 (pdl_field NBPty 4 dec)
  (pdl_name nil
    ('BrRq 1)
    ('LkUp 2)
    ('Reply 3))
 (pdl_field count 4 dec :value_to reg1)
 (pdl_field id 8 dec)
 (loop reg1 'nbp_item)
 (thats_all)
)

(pdl_struct nbp_item
 (pdl_field enet 16 dec)
 (pdl_field enod 8 dec)
 (pdl_field esok 8 dec)
 (funcal 'ddp_socket_names)
 (pdl_field enumb 8 dec)
 (pdl_field Obj 0 cnt_str)
 (pdl_field Typ 0 cnt_str)
 (pdl_field Zon 0 cnt_str)
)

(pdl_struct ATP
 (pdl_field func 2 dec)
  (pdl_name nil
   ('TReq 1)
   ('TResp 2)
   ('TRel 3))
 (pdl_field XO 1 dec)
 (pdl_field EOM 1 dec)
 (pdl_field STS 1 dec)
 (pdl_field 0 3 dec)
 (pdl_field bm_seq 8 hex)
 (pdl_field tid 16 hex)
 (pdl_field usr 32 hex)
)

(pdl_struct EP
 (pdl_field epty 8 dec)
  (pdl_name nil
   ('req 1)
   ('epreply 2))
)

(pdl_struct RTMPreq
 (pdl_field cmd 8 hex)
  (pdl_name nil
    ('request 0x1))
 (thats_all)
)

(pdl_struct ZIP
 (pdl_field zipty 8 dec)
  (pdl_name proto
   (zquery 1)
   (zreply 2)
   (zgodown 3)
   (zgoup 4))
 (pdl_field count 8 dec :value_to reg5)
 (funcal proto)
)

(pdl_struct zquery
 (loop reg5 'zipqry_item)
 (thats_all)
)

(pdl_struct zipqry_item
 (pdl_field net 16 dec)
)

(pdl_struct zreply
 (loop reg5 'zipreply_item)
 (thats_all)
)

(pdl_struct zipreply_item
 (pdl_field net 16 dec)
 (pdl_field nam 0 cnt_str)
)

(pdl_struct zgodown
 (thats_all)
)

(pdl_struct zgoup
 (pdl_field 0 16 dec)
 (pdl_field nam 0 cnt_str)
 (thats_all)
)

(pdl_struct ip
 (pdl_field vers 4 dec)
  (pdl_name nil
   ('IPv4 4))
 (pdl_field ihl 4 dec)
 (pdl_field precd 3 dec)
  (pdl_name nil
   ('net_ctl 7)
   ('i_net_ctl 6)
   ('critic 5)
   ('flash_over 4)
   ('flash 3)
   ('immediate 2)
   ('priority 1)
   ('routine 0))
 (pdl_field delay 1 dec)
  (pdl_name nil
   ('dnormal 0)
   ('dlow 1))
 (pdl_field through 1 dec)
  (pdl_name nil
   ('tnormal 0)
   ('thigh 1))
 (pdl_field reli 1 dec)
  (pdl_name nil
   ('rnormal 0)
   ('rhigh 1))
 (pdl_field 0 2 dec)
 (pdl_field len 16 dec)
 (pdl_field id 16 dec)
 (pdl_field 0 1 dec)
 (pdl_field DF 1 dec)
  (pdl_name nil
  ('may 0)
  ('dont 1))
 (pdl_field MF 1 dec)
  (pdl_name nil
   ('last 0)
   ('fmore 1))
 (pdl_field frago 13 dec)
 (pdl_field live 8 dec :value_to reg6)
 (setq reg6 0)
 (pdl_field ipty 8 dec :counter cnt3)
 (pdl_name ip_type
  (tcp 6)
  (ICMP 1)
  (UDP 17))
 (pdl_field hcks 16 dec)
 (pdl_field sadr 32 ip_addr)
 (pdl_field dadr 32 ip_addr)
 (funcal ip_type)
)

(pdl_struct tcp
 (pdl_field src_port 16 dec)
 (pdl_field dst_prot 16 dec)
 (pdl_field seq 32 dec)
 (pdl_field ackn 32 dec)
 (pdl_field doffs 4 dec)
 (pdl_field 0 6 dec)
 (pdl_field URG 1 dec)
 (pdl_field ACK 1 dec)
 (pdl_field PSH 1 dec)
 (pdl_field RST 1 dec)
 (pdl_field SYN 1 dec)
 (pdl_field FIN 1 dec)
 (pdl_field win 16 dec)
 (pdl_field cks 16 hex)
 (pdl_field urgp 16 hex)
)

(pdl_struct icmp
 (pdl_field icmpty 8 dec)
  (pdl_name proto
   (echo_rply 0)
   (dst_unreach 3)
   (src_quence 4)
   (redirect 5)
   (echo_req 8)
   (time_exceded 11)
   (bad_param 12)
   (timestamp_req 13)
   (timestamp_rply 14)
   (icmp_info_req 15)
   (icmp_info_rply 16))
 (funcal proto)
)

(pdl_struct icmp_echo
 (pdl_field code 8 dec)
  (pdl_name nil
   ('som_echo 0)
 (funcal 'icmp_cks)
)

(pdl_struct icmp_cks
 (pdl_field cks 16 hex)
 (pdl_field unused 32 hex)
 (funcal 'icmp_ip_header)
)

(pdl_struct icmp_ip_header
 (funcal 'ip)
)

(pdl_struct dst_unreach
 (pdl_field code 8 dec)
  (pdl_name nil
   ('net_unreachable 0)
   ('host_unreachable 1)
   ('protocol_unreach 2)
   ('port_unreachable 3)
   ('need_frag_but_DF 4)
   ('src_route_failed 5))
 (funcal 'icmp_cks)
)

(pdl_struct src_quench
 (pdl_field code 8 dec)
  (pdl_name nil
   ('src_too_fast 0)
 (funcal 'icmp_cks)
)

(pdl_struct icmp_redirect
 (pdl_field code 8 dec)
  (pdl_name nil
   ('redirect_net 0)
   ('redirect_host 1)
   ('redirect_srv_net 2)
   ('redirect_srv_host 3))
 (pdl_field cks 16 hex)
 (pdl_field err_ptr 16 hex)
 (pdl_field unused 24 hex)
 (funcal 'icmp_ip_header)
)

(pdl_struct icmp_timex
 (pdl_field code 8 dec)
  (pdl_name nil
   ('time_live_exed 0)
   ('frag_reassm_exed 1))
 (funcal 'icmp_cks)
)

(pdl_struct bad_param
 (pdl_field code 8 dec)
  (pdl_name nil
   ('bad_param_val 0))
 (pdl_field cks 16 hex)
 (pdl_field err_ptr 16 hex)
 (pdl_field unused 24 hex)
 (funcal 'icmp_ip_header)
)

(pdl_struct icmp_time
 (pdl_field code 8 dec)
  (pdl_name nil
   ('som_time 0))
 (pdl_field cks 16 hex)
 (pdl_field id 8 hex)
 (pdl_field seq 8 hex)
 (pdl_field originate 32 dec)
 (pdl_field receive 32 dec)
 (pdl_field transmit 32 dec)
 (thats_all)
)

(pdl_struct icmp_info_req
 (funcal 'cmp_info)
)

(pdl_struct icmp_info_rply
 (funcal 'cmp_info)
)

(pdl_struct icmp_info
 (pdl_field code 8 dec)
  (pdl_name nil
   ('som_type 0))
 (pdl_field cks 16 hex)
 (pdl_field id 8 hex)
 (pdl_field seq 8 hex)
)

(pdl_struct udp
 (pdl_field src_port 16 dec)
 (pdl_field dst_prot 16 dec)
 (pdl_field len 16 dec)
 (pdl_field cks 16 hex)
)

(pdl_struct arp
 (pdl_field ar_hrd 16 dec)
  (pdl_name nil
   ('hrd_ab 3))
 (pdl_field ar_pro 16 dec)
  (pdl_name nil
   ('dod_ip 2048))
 (pdl_field ar_hln 8 dec)
 (pdl_field ar_pln 8 dec)
 (pdl_field ar_op 16 dec)
  (pdl_name nil
   ('op_req 1)
   ('op_reply 2))
 (pdl_field ar_s_anet 16 dec)
 (pdl_field ar_s_node 8 dec)
 (pdl_field ar_s_port 8 dec)
 (pdl_field ar_spa 32 ip_addr)
 (pdl_field ar_t_anet 16 dec)
 (pdl_field ar_t_node 8 dec)
 (pdl_field ar_t_port 8 dec)
 (pdl_field ar_random 32 ip_addr)
 (thats_all)
)

(pdl_struct lddp
 (pdl_field 0 2 hex)
 (pdl_field hop 4 dec)
 (pdl_field ddplen 10 dec)
 (pdl_field cks 16 hex)
 (pdl_field dnet 16 dec)
 (pdl_field snet 16 dec)
 (pdl_field dnod 8 dec)
 (pdl_field snod 8 dec)
 (pdl_field dsok 8 dec)
 (funcal 'socket_names)
 (pdl_field ssok 8 dec)
 (funcal 'socket_names)
 (pdl_field ddpty 8 noprint :value_to reg3)
 (funcal 'ddp_common)
)

(pdl_struct mazewp
 (pdl_field 0 6 hex)
 (pdl_field mazlen 10 dec)
)

(pdl_struct misc_counts
 (pdl_field misc 8 hex :counter cnt4)
  (pdl_name nil
   ('crc_ok 0x0 :on_scope)
   ('crc_bad 0x1)
   ('overrun 0x2)
   ('no_abort 0x3)
   ('tooshort 0x4))
)

