/*
	sp_bomb.c - fatal error handler
*/

#include "sc.h"
#include "sc_seer_globals.h"

/*
	close_windef - close a windef and its window
*/
void close_windef(windef *);
void close_windef(close_me)
windef *close_me;
{CloseWindow(close_me);				/*close the window*/
 close_me->wd_type=WD_free;			/*mark the windef as unused*/
}

void delete_my_windefs()	/*delete any windows I made*/
{register windef *the_windef;
 register int i;
 for(i=0;i<gl.num_windefs;i++) {
 	the_windef=&gl.all_windefs[i];
 	if(the_windef->wd_type!=WD_free)
 		close_windef(the_windef);
	 }
 DisposPtr(gl.all_windefs);
 gl.num_windefs=0;
}

/*
	Draw a string from a STR# in the resource file
*/
char DrawResString(int,int);
char DrawResString(what_res_id,what_index)
int what_res_id;
int what_index;
{Str255 the_str;
 GetIndString(the_str,what_res_id+gl.res_base,what_index);
 if((*the_str)!=0) {	/*find the string?*/
 	DrawString(the_str); /*yes, draw it*/
 	return;}			/*we are done, return*/
 /*couldn't find the string, see how to report that*/
 if(gl.bomb_active==0)		/*ok to bomb?*/
 	bomb(BOMB_string,BMB_no_os,BMB_no_special); /*yes, do so*/
 /*we don't have a name for the requested string, but the fatal error
 	handler is already active, it probably is trying to say that there
 	is no resource file or some such, anyway print out the numbers
 	which is better than nothing.
*/
 DrawString("\pid=");
 DrawNum(what_res_id+gl.res_base);
 DrawString("\p/index=");
 DrawNum(what_index+gl.res_base);
}


/*
	Draw a decimal long on the current port
*/
void DrawNum(anum)
long anum;
{Str255 tmpstr;
 NumToString(anum,tmpstr);
 DrawString(tmpstr);
}

/*
	fatal error handler
*/
void bomb(bomb_type,os_err,bomb_special)
int bomb_type;		/*a bomb_... index*/
int os_err;			/*os error code or zero*/
long bomb_special;	/*for expansion*/
{GrafPtr bomb_window;
 WindowRecord bomb_storage;
 Rect temp_rect;
 if(gl.bomb_active>=3)		/*get a recursive error three times?*/
 	SysError(11);			/*yes, try harder to die*/
 if(gl.bomb_active==2)		/*been here once before?*/
  longjmp(gl.seer_exit_lngjmp,1); /*yes, try not to come back*/
 gl.bomb_active++;			/*say that bomb has been entered*/
 SysBeep(1);				/*attract attention*/

 /*close the seer device, don't bomb if it fails (close checks
    bomb_active)
*/
 close_seer();
 SetRect(&temp_rect,44,44,500,300);	/*bomb window bounds*/
 bomb_window=NewWindow(
 	&bomb_storage,		/*put the window storage here*/
 	&temp_rect,			/*window bounds*/
 	"\PFatal Error",	/*the window name*/
 	TRUE,				/*it is visible*/
 	0,					/*a normal window*/
 	-1L,				/*it goes in front*/
 	FALSE,				/*no goaway*/
 	0L);				/*refcon*/

 if(bomb_window==NIL)		/*do we have a window?*/
   GetWMgrPort(&bomb_window);	/*no put fatal message on window managers port*/
 else
 	((WindowPeek)bomb_window)->windowKind=gl.win_ref_num;

 SetPort(bomb_window);
 EraseRect(&bomb_window->portRect);	/*make the message show up*/

#define BM_name 		1
#define BM_os_err 		2
#define BM_click_mouse	3
#define BM_add_dat	4
 MoveTo(5,20);			/*say that there is a problem*/
 DrawResString(STRN_bomb_txt,BM_name);
 DrawResString(STRN_BOMB,bomb_type);

 if(os_err!=0) {		/*does os_err apply to this bomb?*/
 	MoveTo(5,40);
 	DrawResString(STRN_bomb_txt,BM_os_err);
 	DrawNum((long)os_err);
 	}
 	
 /*print the extra field used by some bombs.  really should
    format this according to bomb type*/
 MoveTo(6,60);
 DrawResString(STRN_bomb_txt,BM_add_dat);
 DrawNum(bomb_special);

 MoveTo(5,80);
 DrawResString(STRN_bomb_txt,BM_click_mouse);	/*click mouse message*/

 while(!Button());		/*wait for a click*/
#ifdef xxxyyy
 delete_my_windefs();	/*delete any windows I made*/
#endif
 longjmp(gl.seer_exit_lngjmp,1); /*quit seer*/
}