/*
	sc_event.c - seer da/program common events
*/
#include "sc.h"
#include "sc_seer_globals.h"
#include "sc_event.h"
#include "sc_packet_window.h"

static ControlHandle ev_ctl;	  /*the control for the current event*/

/*
	the current position in the queue has been changed, update
	the slider to reflect this.
*/
void fix_slider(void);
void fix_slider()			/*reset the slider position*/
{long cur_pos;
 /* check for position zero, since if position is zero, size may be
    also and we don't want to divide by zero
 */
 if(PAK_wdf->draw_packet_num==0)
 	cur_pos=0;
 else
 	cur_pos=FracMul((long)GetCtlMax(ev_ctl),
 				 FracDiv(PAK_wdf->draw_packet_num,
 				 	     PAK_wdf->draw_pak_max));
 SetCtlValue(ev_ctl,(int)cur_pos);
}

/*
	pak_scroll - user wants to scroll the display
*/
void pak_scroll(long);
void pak_scroll(how_far)
long how_far;
{register long new_loc;
 new_loc=PAK_wdf->draw_packet_num + how_far;
 new_loc = min(new_loc,PAK_wdf->draw_pak_max);
 new_loc = max(0,new_loc);	/*don't go to far back*/
 
 /* update clipped how far to scroll */
 how_far = new_loc - PAK_wdf->draw_packet_num;
 PAK_wdf->draw_packet_num = new_loc;
 fix_slider();			/*reset the slider position*/
 /*already displaying displaying the desired packet? */
 if(how_far == 0)
  return;			/*yes, all done*/
 scroll_draw_packets(how_far);
}

/*
	the slider was moved by draging, move the displayed text to match it
*/
void pak_thumb(void);
void pak_thumb()
{long cur_pos;
 cur_pos = FracMul(PAK_wdf->draw_pak_max,
 			FracDiv((long)GetCtlValue(ev_ctl),(long)GetCtlMax(ev_ctl)));
 pak_scroll(cur_pos-PAK_wdf->draw_packet_num);
}

pascal void track_thumb(void);
pascal void track_thumb()
{
}

void new_max_packet(void);
void new_max_packet()
{PAK_wdf->draw_pak_max=sp_status->h_inuse-1;
}

/*
	scroll down one packet, if aleady at the end of packets
	then update the end of available packets
*/
void pak_scroll_down(int);
void pak_scroll_down(dist)
int dist;
{/* atempting to scroll of the end of packets? */
 if(PAK_wdf->draw_pak_max<=
    PAK_wdf->draw_packet_num)
 		new_max_packet(); /* yes, scroll off end by geting a new end*/
 pak_scroll(dist);
}

#define PAGE_SIZE (5)	/* number of packets to scroll in page up/down */
pascal void track_nothumb(ControlHandle,int);
pascal void track_nothumb(a_ctl,a_part)
register ControlHandle a_ctl;
register int a_part;
{iSETUP_GLOBAL_REG
 switch(a_part) {
 case inUpButton:
	pak_scroll(-1L);
	break;
 case inDownButton:
	pak_scroll_down(1L);
 	break;
 case inPageUp:
	pak_scroll((long)-PAGE_SIZE);
	break;
 case inPageDown:
	pak_scroll_down((long)PAGE_SIZE);
	break;
 }
 iRESTORE_GLOBAL_REG
}

/*handle mouse down in the content region*/
void e_pak_down_content(the_event)
EventRecord *the_event;
{Point down_at;			/*where the mouse went down*/
 int a_part;			/*part code of the selected control*/
 int a_value;			/*the selected controls value*/
 down_at=the_event->where; /*say where mouse went down*/
 GlobalToLocal(&down_at); /*find control likes local coordinates*/
 /*see if this is a control action*/
 if(FindControl(down_at,FrontWindow(),&ev_ctl)!=0) {
   a_part=TestControl(ev_ctl,down_at);	/*see what kind of control it is*/ 
   if(a_part==inThumb) {
   	a_part=TrackControl(ev_ctl,down_at,&track_thumb);
   	pak_thumb();		/*jump packet display to current control setting*/
   	}
   else
   /*yes, a control, track the control*/
   	a_part=TrackControl(ev_ctl,down_at,&track_nothumb);
   a_value=GetCtlValue(ev_ctl);		/*if the control action wasn't aborted*/
   } /* if a control */
 else
   /* if down where the grow area would be, pretend it we should
      grow.  DA windows can't grow normaly so we check down in grow here
      Probably should also check active
   */
   if((down_at.h>(CUR_WINDOW->portRect.right-SCROLL_BAR_PIXLS))&&
      (down_at.v>(CUR_WINDOW->portRect.bottom-SCROLL_BAR_PIXLS)))
   e_pak_grow(the_event->where);
}
