/*
	SRr_getpak.c - return a queue entry
*/
#include "seer_interface.h"
#include "seer_private.h"

int SRr_getpak(cb)
register SR_record *cb;
{register char *my_pak_pt;/*packet address as a pointer*/
 {register long pak_offset;
  pak_offset=cb->x.a_getpak.pak_num;	/*start at last packet released*/
  pak_offset -=sd.ast.pre_pak_num;/*see how far forward to go in the queue*/
  if(pak_offset<=0)			/*already passed?*/
   return SRe_never;			/*yes, already gone*/
  if(pak_offset>sd.ast.h_inuse)/*arrived yet?*/
   return SRe_notyet;		/*that packet hasn't come in yet*/

  pak_offset--;				/*offset 1 points to current, make 0 point current*/
  pak_offset <<=2;			/*convert to a byte address*/
 /*we know the desired packet exists, find its address*/
  my_pak_pt = sd.hq.bufreadpt+pak_offset;/*point to the packet*/
  }/*end of register pak_offset*/
 WRAP_hq_pt(my_pak_pt);	/*wrap header pointer into queue*/

/*
	we have found the desired packet - decode and return it
*/
 {register uint8 hflags;	/*the packet flags*/
  register char *dpt; 		/*pointer to packet data*/
  register uint32 size;		/*the packet size*/
  int err;					/*remember the error so know to bash size*/
  hflags=((pak_hdr *)my_pak_pt)->flags;/*load the hardware error flags into each flag*/
 /*convert the hardware error flags to an error code*/
  err= cb->x.a_getpak.pak_err= (hflags & srphfl_ERR_mask);
 
 /*remember where the packet starts*/
  dpt=(char *)((pak_hdr *)my_pak_pt)->address;
  cb->x.a_getpak.pak_data=dpt; 	/*return packet address*/	

  if(hflags&srphfl_WRAP) {		/*up against the end of the data queue?*/
   size=sd.dq_final-dpt;			/*yes, last packet size is funny*/
   }
  else {	/*it wasn't the last packet before end of the data queue*/
   	my_pak_pt +=sizeof(pak_hdr);	/*point to the next entry*/
   	WRAP_hq_pt(my_pak_pt);			/*wrap the pointer into the queue*/
  	SCC_interupts_off;				/*get a consistant bufwritept*/
  	if(my_pak_pt==sd.hq.bufwritept)/*the last packet in the queue?*/
  	 size=(uint32)sd.dq.bufwritept;/*yes, next data is bufwritept then*/
  	else							/*else, next data is start of next packet*/
  	 size=((pak_hdr *)my_pak_pt)->address;
  	SCC_interupts_on;
	size -= (uint32)dpt;			/*size is next - current*/
  	}/*end else*/
 /*size is set now based on where the next packet starts*/
  if(hflags&srphfl_ODD)				/*was the packet odd length?*/
  	size--;							/*yes, don't count the padding then*/
  if(err<=PE_havecrc)				/*have a hardware crc?*/
    size=max(0,size-2);				/*yes, take that out of the packet*/
  cb->x.a_getpak.pak_size=size;		/*we finaly know the packet size*/
 /*the hardware crc is logically part of the header, put it there
		*************** bash on dpt ***************************
 */
   {register uint8 high_crc;
    dpt += size;
    high_crc = *dpt++;
    cb->x.a_getpak.pak_crc= (high_crc<<8)|(*dpt);/*record the crc in header*/
   }
  }/*end of register declarations*/

 cb->x.a_getpak.pak_time=0;			/*time not implemented yet*/
 return SRe_noErr;
}
