/*
	SRr_release.c - release packets from queue
*/
#include "seer_interface.h"
#include "seer_private.h"

int SRr_release(cb)
register SR_record *cb;
{register char *nxt_hp;
 pak_hdr *cur_hp;
 register uint8 hflags;
 cur_hp=(pak_hdr *)sd.hq.bufreadpt;
 if(sd.hq.bufwritept==(char *)cur_hp)
  	return SRe_never;		/*the queue is empty*/
 /*there is a packet in the queue to release*/
 hflags=cur_hp->flags; 		/*need the odd and final flags*/
 nxt_hp=(char *)cur_hp;		/*point to the current header*/
 nxt_hp +=sizeof(pak_hdr);	/*advance to the next*/
 WRAP_hq_pt(nxt_hp);		/*wrap it into the queue*/

 if(hflags&srphfl_WRAP) {	/*the data queue wrap around here?*/
 	SCC_interupts_off;		/*keep counters/pointer consistant*/
 	sd.hq.bufreadpt=nxt_hp;	/*advance the header pointer*/
	sd.ast.h_inuse--;		/*one less header in use*/
 	sd.ast.d_inuse -= sd.dq.bufendpt - sd.dq.bufreadpt; /*account for space freed*/
  	sd.dq.bufreadpt=sd.dq.bufstartpt; /*yes, so wrap it*/
   	SCC_interupts_on;
   	}
else {
	register  char *newdq;
 	SCC_interupts_off;			/*keep counters/pointer consistant*/
 	sd.hq.bufreadpt=nxt_hp;		/*advance the read pointer*/
	sd.ast.h_inuse--;			/*one less header in use*/
	if(nxt_hp==sd.hq.bufwritept) /*next in data write?*/
	 newdq=sd.dq.bufwritept; 	/*yes, so advance data read upto write*/
	else
  	 newdq=(char *)((pak_hdr *)nxt_hp)->address; /*advance to the start of next packet*/
	sd.ast.d_inuse -= newdq-sd.dq.bufreadpt; /*account for the space freed*/
	sd.dq.bufreadpt=newdq;
  	SCC_interupts_on;
  	}

 sd.ast.pre_pak_num++;
 return SRe_noErr;
}

